library ieee;
use ieee.std_logic_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.NUMERIC_STD.ALL;

entity tb_top is
end tb_top;

architecture tb of tb_top is
    component top
        port (
              clk      : in std_logic;
              rst      : in std_logic;
              s        : in unsigned (7 downto 0);  --precio producto max 255
              a        : in unsigned (7 downto 0);  -- valor de moneda moneda max 255 (1,2,50,20,10,5)
              c        : in std_logic; --pulso de introducir moneda
              d        : out std_logic; --pulso de salida valida 
              cambio   : out unsigned (8 downto 0); --valor de cambio
              d_cambio : out std_logic; --seal de devolucion
              
              --Nmonedas : out unsigned (3 downto 0); --cuenta monedas
              --Ttiempo : out std_logic_vector (5 downto 0); --40 clk           
              error    : out std_logic);
    end component;

    signal clk      : std_logic;
    signal rst      : std_logic;
    signal s        : unsigned (7 downto 0);
    signal a        : unsigned (7 downto 0);
    signal c        : std_logic;
    signal d        : std_logic;
    signal cambio   : unsigned (8 downto 0);
    signal d_cambio : std_logic;
    --signal Nmonedas: unsigned(3 downto 0);
    --signal Ttiempo : std_logic_vector (5 downto 0);--40 clk
    signal error    : std_logic;
    signal consola: std_logic;
     
    --constant TbPeriod : time := 20 ns;
    constant TbPeriod : time := 10 ns; --para mayor de 10 monedas
begin
    dut : top
    port map (clk=>clk,rst=> rst,s=> s,a=> a, c=> c,d => d,
    cambio=> cambio,d_cambio => d_cambio, error => error);
    -- Nmonedas => Nmonedas , Ttiempo => Ttiempo);
    process
        begin 
           rst <= '1';
           wait for 10 ns;
           rst <= '0';
           wait;
    end process;
    process
        begin
           clk<='0';
           wait for TbPeriod/2;
           clk<='1';
           wait for TbPeriod/2;            
    end process;
stimuli : process
begin

    s <= "11001000";
    if (s = "11001000") then 
        report "aqui pasa";
    else
        report "aqui hay error";
    end if;  
    wait;
end process;

test1: process
begin
    s <= "11001000"; --precio del producto 200
    a <= "00000101"; --introduzco 5
    if (a= "00000101" ) then
    elsif(s ="11001000" and error='0' and d_cambio='1') then
            report "PASS";
    else
        report "FAIL";
    end if;
 --end process


-- TEST 1: Precio producto: 2
--      s <= "11001000"; --precio del producto 200
--      a <= "00000101"; --introduzco 5
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "00001010"; --introduzco 10
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2; 
--      c <= '0';              
--      a <= "00010100"; --introduzco 20
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';                         
--      a <= "00001010"; --introduzco 10
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                                
--      c <= '0';
--      a <= "00000101"; --introduzco 5
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait;   
     
--      if (s="11001000" and error='0' and d_cambio='1' ) then                                          
--            consola<= '1';
--      else
--            consola<='0';
--      end if;     
--      assert consola=1
--      report integer'image(consola) & "FAIL"    
--      severity failure;
            
--  TEST 2: Precio producto: > 2  
--      s <= "11001011"; --precio del producto 203
--      a <= "00000101"; --introduzco 5
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0'; 
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;  
--      c <= '0';     
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait;     
--     if (s="11111111" and error='0' and d_cambio='1' ) then
--        consola<='1';
--        report "PASS";    
--     else
--        consola<='0';
--        report "FAIL";
 
--TEST 3 precio producto: 0 euros  
--      s <= "00000000"; -- precio del producto 0
----    a <= "11001000"; -- monedas que entra 200
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait;
--      if (s="00000000" and error='1' and d_cambio='0' ) then
--      consola<='1';
--      report "PASS";    
--      else
--      consola<='0';
--      report "FAIL";

-- TEST 4: Acepta todas las monedas
--      s <= "11001000"; --precio del producto 200 
--      a <= "00000101"; --introduzco 5
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "00001010"; --introduzco 10
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "00010100"; --introduzco 20
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "11001000"; --introduzco 200
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait; 
--      if (error='0' and d_cambio='1') then        
--            consola<='1';
--            report "PASS";    
--      else
--            consola<='0';
--            report "FAIL";
  
 
-- TEST 5: Monedas insuficientes (precio 2 )
--      s <= "11001000"; --precio del producto 200
--      a <= "00000101"; --monedas que entra 5
--      c <= '0';
--      wait for 100 ns;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2; 
--      c <= '0';
--      a <= "00001010"; --introduzco 10
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "00010100"; --introduzco 20
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait;        
--        if (error='1' and d_cambio='0') then        
--            consola<='1';
--            report "PASS";    
--        else
--           consola<='0';
--            report "FAIL";
                   
--  TEST 6: Monedas necesarias (precio 2 )        
--      s <= "11001000"; --precio del producto 200
--      a <= "11001000"; --monedas que entra 200
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait;       
--      if (error='0' and d_cambio='1') then        
--            consola<='1';
--            report "PASS";    
--      else
--            consola<='0';
--            report "FAIL";         
        
--  TEST 7:  Monedas suficientes (precio 2 )
--      s <= "11001000"; --precio del producto 200
--      a <= "11001000"; --introduzco 200
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2; 
--      c <= '0';
--      a <= "01100100"; --monedas que entra 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait;              
--      if (error='0' and d_cambio='1') then        
--            consola<='1';
--            report "PASS";    
--      else
--            consola<='0';
--            report "FAIL";
      
---- TEST 8: N monedas introducidas: 10
--      s <= "11001000"; --precio del producto 200
--      a <= "11001000"; --introduzco 200
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;               
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                         
--      a <= "00010100"; --introduzco 20
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                                
--      a <= "00000101"; --introduzco 5
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      a <= "11001000"; --introduzco 200
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                                       
--      a <= "00010100"; --introduzco 20
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                                                        
--      a <= "00001010"; --introduzco 10
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait;
--      if (error='0' and d_cambio='1') then        
--            consola<='1';
--            report "PASS";    
--      else
--            consola<='0';
--            report "FAIL";

-- TEST 9: N monedas introducidas: >10
--      s <= "11001000"; --precio del producto 200
--      a <= "11001000"; --introduzco 200
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;               
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                         
--      a <= "00010100"; --introduzco 20
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                                
--      a <= "00000101"; --introduzco 5
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;
--      a <= "11001000"; --introduzco 200
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                                       
--      a <= "00010100"; --introduzco 20
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                                                        
--      a <= "00001010"; --introduzco 10
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2; 
--      a <= "00001010"; --introduzco 10
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';      
--      wait;
--      if (error='0' and d_cambio='1') then        
--            consola<='1';
--            report "PASS";    
--      else
--            consola<='0';
--            report "FAIL";
            
-- TEST 10: Se introduce moneda antes 40 clk
--      s <= "01100100"; --precio del producto 200
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*;
--      c <= '1';
--      wait for TbPeriod*;
--      c <= '0'; 
--      wait for TbPeriod*2;
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;                                                        
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2; 
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait; 
--      if (error='0' and d_cambio='1') then        
--            consola<='1';
--            report "PASS";    
--      else
--            consola<='0';
--            report "FAIL";  
  
--  TEST 11: Se introduce moneda justo 40 clk
--      s <= "11001000"; --precio del producto 200
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0'; 
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2;    
--      c <= '0';                                                    
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait for TbPeriod*2; 
--      c <= '0';
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait;     
--      if (error='0' and d_cambio='1') then        
--            consola<='1';
--            report "PASS";    
--      else
--            consola<='0';
--            report "FAIL";
          
--  TEST 12: Se introduce moneda despus 40 clk
--      s <= "11001000"; --precio del producto 200
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0'; 
--      wait for TbPeriod*2;
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      a <= "01100100"; --introduzco 100
--      c <= '0';
--      wait for TbPeriod*3;
--      c <= '1';
--      wait for TbPeriod*3;
--      c <= '0';
--      wait for TbPeriod;                                                        
--      c <= '0';      
--      a <= "00110010"; --introduzco 50
--      c <= '0';
--      wait for TbPeriod*2;
--      c <= '1';
--      wait for TbPeriod*2;
--      c <= '0';
--      wait;    
--      if (error='1' and d_cambio='1') then        
--            consola<='1';
--            report "PASS";    
--      else
--            consola<='0';
--            report "FAIL";
        
end process;
end tb;